--- dmesg_3.8.0-rc4-1-drmkmslocking-generic.txt	2013-01-20 22:06:22.210360381 +0100
+++ dmesg_3.8.0-rc4-1-drmkmslocking-generic_after-suspend-resume.txt	2013-01-20 22:07:42.787453915 +0100
@@ -773,3 +773,93 @@
 [  308.141128] show_signal_msg: 45 callbacks suppressed
 [  308.141134] firefox[2249]: segfault at 7f0c01627428 ip 00007f0c01608362 sp 00007fff607a0418 error 7 in libGL.so.1.2.0[7f0c01608000+7c000]
 [  900.851908] type=1400 audit(1358715135.734:27): apparmor="DENIED" operation="capable" parent=1 profile="/usr/sbin/cupsd" pid=1021 comm="cupsd" pid=1021 comm="cupsd" capability=36  capname="block_suspend"
+[ 1793.168213] wlan0: deauthenticating from 00:04:0e:e4:00:3d by local choice (reason=3)
+[ 1793.216654] cfg80211: Calling CRDA to update world regulatory domain
+[ 1793.221518] cfg80211: World regulatory domain updated:
+[ 1793.221522] cfg80211:   (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
+[ 1793.221524] cfg80211:   (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
+[ 1793.221526] cfg80211:   (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
+[ 1793.221528] cfg80211:   (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
+[ 1793.221529] cfg80211:   (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
+[ 1793.221530] cfg80211:   (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
+[ 1795.281966] PM: Syncing filesystems ... done.
+[ 1795.286182] PM: Preparing system for mem sleep
+[ 1795.636102] Freezing user space processes ... (elapsed 0.01 seconds) done.
+[ 1795.650389] Freezing remaining freezable tasks ... (elapsed 0.01 seconds) done.
+[ 1795.666339] PM: Entering mem sleep
+[ 1795.666428] Suspending console(s) (use no_console_suspend to debug)
+[ 1795.666744] sd 1:0:0:0: [sdb] Synchronizing SCSI cache
+[ 1795.666828] sd 0:0:0:0: [sda] Synchronizing SCSI cache
+[ 1795.666968] sd 0:0:0:0: [sda] Stopping disk
+[ 1795.669298] sd 1:0:0:0: [sdb] Stopping disk
+[ 1796.277989] PM: suspend of devices complete after 611.859 msecs
+[ 1796.278142] PM: late suspend of devices complete after 0.149 msecs
+[ 1796.293970] r8169 0000:02:00.0: System wakeup enabled by ACPI
+[ 1796.373849] PM: noirq suspend of devices complete after 95.770 msecs
+[ 1796.374180] ACPI: Preparing to enter system sleep state S3
+[ 1796.397916] PM: Saving platform NVS memory
+[ 1796.404046] Disabling non-boot CPUs ...
+[ 1796.405439] smpboot: CPU 1 is now offline
+[ 1796.407401] smpboot: CPU 2 is now offline
+[ 1796.408195] Broke affinity for irq 9
+[ 1796.409254] smpboot: CPU 3 is now offline
+[ 1796.409563] Extended CMOS year: 2000
+[ 1796.410905] ACPI: Low-level resume complete
+[ 1796.410952] PM: Restoring platform NVS memory
+[ 1796.412152] Extended CMOS year: 2000
+[ 1796.412217] Enabling non-boot CPUs ...
+[ 1796.412293] smpboot: Booting Node 0 Processor 1 APIC 0x1
+[ 1796.423290] Disabled fast string operations
+[ 1796.425798] CPU1 is up
+[ 1796.425867] smpboot: Booting Node 0 Processor 2 APIC 0x2
+[ 1796.436802] Disabled fast string operations
+[ 1796.439266] CPU2 is up
+[ 1796.439336] smpboot: Booting Node 0 Processor 3 APIC 0x3
+[ 1796.450372] Disabled fast string operations
+[ 1796.452919] CPU3 is up
+[ 1796.457731] ACPI: Waking up from system sleep state S3
+[ 1796.648350] PM: noirq resume of devices complete after 144.046 msecs
+[ 1796.648492] PM: early resume of devices complete after 0.103 msecs
+[ 1796.648535] i915 0000:00:02.0: setting latency timer to 64
+[ 1796.648550] ehci-pci 0000:00:1a.0: setting latency timer to 64
+[ 1796.648600] ehci-pci 0000:00:1d.0: setting latency timer to 64
+[ 1796.648629] mei 0000:00:16.0: irq 47 for MSI/MSI-X
+[ 1796.648638] ahci 0000:00:1f.2: setting latency timer to 64
+[ 1796.648726] snd_hda_intel 0000:00:1b.0: irq 50 for MSI/MSI-X
+[ 1796.648729] r8169 0000:02:00.0: System wakeup disabled by ACPI
+[ 1796.648777] iwlwifi 0000:01:00.0: RF_KILL bit toggled to enable radio.
+[ 1796.648844] usb usb3: root hub lost power or was reset
+[ 1796.648847] usb usb4: root hub lost power or was reset
+[ 1796.653679] xhci_hcd 0000:03:00.0: irq 41 for MSI/MSI-X
+[ 1796.653691] xhci_hcd 0000:03:00.0: irq 42 for MSI/MSI-X
+[ 1796.653698] xhci_hcd 0000:03:00.0: irq 43 for MSI/MSI-X
+[ 1796.653710] xhci_hcd 0000:03:00.0: irq 44 for MSI/MSI-X
+[ 1796.653717] xhci_hcd 0000:03:00.0: irq 45 for MSI/MSI-X
+[ 1796.876231] usb 1-1.4: reset high-speed USB device number 3 using ehci-pci
+[ 1796.984029] ata4: SATA link down (SStatus 0 SControl 300)
+[ 1796.992029] ata5: SATA link down (SStatus 0 SControl 300)
+[ 1797.008046] ata2: SATA link up 3.0 Gbps (SStatus 123 SControl 300)
+[ 1797.012235] ata2.00: configured for UDMA/133
+[ 1797.028099] sd 1:0:0:0: [sdb] Starting disk
+[ 1798.395223] [drm] Enabling RC6 states: RC6 on, RC6p off, RC6pp off
+[ 1799.070554] ata1: SATA link up 3.0 Gbps (SStatus 123 SControl 300)
+[ 1799.071901] ata1.00: failed to get Identify Device Data, Emask 0x1
+[ 1799.073329] ata1.00: failed to get Identify Device Data, Emask 0x1
+[ 1799.073337] ata1.00: configured for UDMA/133
+[ 1799.086662] sd 0:0:0:0: [sda] Starting disk
+[ 1799.107484] PM: resume of devices complete after 2460.726 msecs
+[ 1799.107665] PM: Finishing wakeup.
+[ 1799.107666] Restarting tasks ... done.
+[ 1799.116325] video LNXVIDEO:00: Restoring backlight state
+[ 1799.464705] iwlwifi 0000:01:00.0: L1 Enabled; Disabling L0S
+[ 1799.471329] iwlwifi 0000:01:00.0: Radio type=0x1-0x2-0x0
+[ 1799.719333] IPv6: ADDRCONF(NETDEV_UP): wlan0: link is not ready
+[ 1806.001863] wlan0: authenticate with 00:04:0e:e4:00:3d
+[ 1806.008008] wlan0: send auth to 00:04:0e:e4:00:3d (try 1/3)
+[ 1806.009702] wlan0: authenticated
+[ 1806.009823] iwlwifi 0000:01:00.0 wlan0: disabling HT as WMM/QoS is not supported by the AP
+[ 1806.009828] iwlwifi 0000:01:00.0 wlan0: disabling VHT as WMM/QoS is not supported by the AP
+[ 1806.013543] wlan0: associate with 00:04:0e:e4:00:3d (try 1/3)
+[ 1806.017823] wlan0: RX AssocResp from 00:04:0e:e4:00:3d (capab=0x411 status=0 aid=1)
+[ 1806.023255] wlan0: associated
+[ 1806.023291] IPv6: ADDRCONF(NETDEV_CHANGE): wlan0: link becomes ready